import 'package:flutter/material.dart';
import 'package:test_sa/extensions/context_extension.dart';
import 'package:test_sa/extensions/int_extensions.dart';
import 'package:test_sa/extensions/widget_extensions.dart';
import 'package:test_sa/models/all_requests_and_count_model.dart';
import 'package:test_sa/models/new_models/dashboard_detail.dart';
import 'package:test_sa/modules/pm_module/ppm_wo/ppm_details_page.dart';
import 'package:test_sa/new_views/app_style/app_color.dart';
import 'package:test_sa/views/widgets/item_views/info_date_widget.dart';
import 'package:test_sa/views/widgets/item_views/info_header_widget.dart';
import 'package:test_sa/views/widgets/item_views/info_text_widget.dart';
import 'package:test_sa/views/widgets/requests/request_status.dart';

class PpmItemView extends StatelessWidget {
  final Data? requestData;
  final RequestsDetails? requestDetails;
  final bool showShadow;

  const PpmItemView({Key? key, this.requestData, this.requestDetails, this.showShadow = true}) : super(key: key);

  @override
  Widget build(BuildContext context) {
    if (requestData != null) {
      return Column(
        crossAxisAlignment: CrossAxisAlignment.start,
        children: [
          Row(
            crossAxisAlignment: CrossAxisAlignment.start,
            children: [
              // StatusLabel(
              //   label: requestData!.priorityName!,
              //   textColor: AppColor.getRequestStatusTextColorByName(context, requestData!.priorityName!),
              //   backgroundColor: AppColor.getRequestStatusColorByName(context, requestData!.priorityName!),
              // ),
              // 8.width,
              StatusLabel(
                label: requestData!.statusName!,
                textColor: AppColor.getRequestStatusTextColorByName(context, requestData!.statusName!),
                backgroundColor: AppColor.getRequestStatusColorByName(context, requestData!.statusName!),
              ),
              1.width.expanded,
              InfoDateWidget(requestData!.transactionDate ?? ""),
            ],
          ),
          InfoHeaderWidget(requestData?.typeTransaction ?? context.translation.ppmRequest),
          InfoTextWidget(label: context.translation.assetName, value: requestData!.assetName),
          InfoTextWidget(label: context.translation.assetNumber, value: requestData!.assetNumber),
          // '${context.translation.assetSN}: ${request.assetSN}'.bodyText(context),//todo ask ahmed
          // '${context.translation.code}: ${request.code}'.bodyText(context),
          InfoTextWidget(label: 'PM No', value: requestData!.requestNo, showArrow: true),
        ],
      ).toShadowContainer(context, withShadow: showShadow).onPress(() {
        Navigator.of(context).push(MaterialPageRoute(builder: (_) => PpmDetailsPage(requestId: requestData!.id!)));
      });
    }
    if (requestDetails != null) {
      return Column(
        crossAxisAlignment: CrossAxisAlignment.start,
        spacing: 1,
        children: [
          Row(
            crossAxisAlignment: CrossAxisAlignment.start,
            children: [
              // StatusLabel(
              //   label: requestDetails!.priority!,
              //   textColor: AppColor.getRequestStatusTextColorByName(context, requestDetails!.priority!),
              //   backgroundColor: AppColor.getRequestStatusColorByName(context, requestDetails!.priority!),
              // ),
              // 8.width,
              StatusLabel(
                label: requestDetails!.status!,
                textColor: AppColor.getRequestStatusTextColorByName(context, requestDetails!.status!),
                backgroundColor: AppColor.getRequestStatusColorByName(context, requestDetails!.status!),
              ),
              1.width.expanded,
              InfoDateWidget(requestDetails!.date ?? ""),
            ],
          ),
          InfoHeaderWidget(requestDetails?.nameOfType ?? context.translation.ppmRequest),
          InfoTextWidget(label: context.translation.assetName, value: requestDetails!.assetName),
          InfoTextWidget(label: context.translation.assetNumber, value: requestDetails!.assetNo),
          InfoTextWidget(label: context.translation.assetSN, value: requestDetails!.assetSN),
          // '${context.translation.code}: ${request.code}'.bodyText(context),
          InfoTextWidget(label: 'PM No', value: requestDetails!.requestNo, showArrow: true),
        ],
      ).toShadowContainer(context, withShadow: showShadow).onPress(() {
        Navigator.of(context).push(MaterialPageRoute(builder: (_) => PpmDetailsPage(requestId: requestDetails!.id!)));
      });
    }
    return SizedBox();
  }
}
